area
	layer=3
	invisibility=1
	mouse_opacity=0
	icon='Other.dmi'
	icon_state="Grid"

var/obj/Overlays/AutoEdgeOverlay/AutoEdgeOverlay=new()
obj/Overlays
	AutoEdgeOverlay
		icon='Turfs.dmi'

obj/Shadows
	icon='Shadows.dmi'
	mouse_opacity=0

turf
	var/Height=0
	var/AutoEdge=0
	var/list/EdgeProtection
	icon='Turfs.dmi'
	New()
		if(src.AutoEdge)	for(var/turf/T in oview(1,src))	T.AddEdges()
		return ..()
	proc/AddEdges()
		src.overlays=null
		for(var/turf/T in oview(1,src))
			if(T.AutoEdge==2 && src.density)	continue
			if(src.AutoEdge && T.AutoEdge)	if(src.AutoEdge<T.AutoEdge)	continue
			if(T.x==src.x || T.y==src.y)
				if(T.AutoEdge && T.type!=src.type)
					if(!(get_dir(src,T) in src.EdgeProtection))
						global.AutoEdgeOverlay.icon_state="[T.icon_state][get_dir(T,src)]"
						src.overlays+=global.AutoEdgeOverlay
	Grass
		AutoEdge=1
		icon_state="Grass"
	Floor
		AutoEdge=2
		icon_state="Floor"
	Dirt
		icon_state="Dirt"
	Water
		opacity=1
		density=1
		icon_state="Water"
	Wall
		opacity=1
		density=1
		icon_state="Wall"
		EdgeProtection=list(EAST,NORTH,WEST)
	WallTops
		opacity=1
		density=1
		icon_state="WallTopT"
		EdgeProtection=list(EAST,NORTH,WEST)