mob/verb
	ToggleOptions()
		set hidden=1
		var/BOOL="true"
		if(src.OptionsOpen)	BOOL="false"
		src.OptionsOpen=!src.OptionsOpen
		var/Winsets="MainWindow.MusicButton.is-visible=[BOOL];MainWindow.SoundEffectsButton.is-visible=[BOOL];MainWindow.ToolTipsButton.is-visible=[BOOL];MainWindow.MainMap.focus=true"
		winset(src,null,Winsets)
	ToggleGoldModes()
		set hidden=1
		var/BOOL="true"
		if(src.GoldModesOpen)	BOOL="false"
		src.GoldModesOpen=!src.GoldModesOpen
		var/Winsets="MainWindow.SplitGoldButton.is-visible=[BOOL];MainWindow.SharedGoldButton.is-visible=[BOOL];MainWindow.EarnedGoldButton.is-visible=[BOOL];MainWindow.MainMap.focus=true;"
		Winsets+="MainWindow.SplitLabel.is-visible=[BOOL];MainWindow.SharedLabel.is-visible=[BOOL];MainWindow.EarnedLabel.is-visible=[BOOL];MainWindow.GoldNoteLabel.is-visible=[BOOL]"
		winset(src,null,Winsets)
	SetGoldMode(var/NewGoldMode as null|text)
		set hidden=1
		if(!Wave)
			GoldMode=NewGoldMode
			for(var/mob/Player/P in world)	if(P.client)	winset(P,"MainWindow.GoldModeButton","text='Gold: [GoldMode]'")
		src.ToggleGoldModes()
	ToggleSpectate()
		set hidden=1
		if(src in Players)
			Players-=src
			Spectators+=src
			src.TroopHUD()
			src.EscapeKey()
			src.UpdateGold()
			src.GoldModesOpen=0
			if(src.see_invisible)	src.ToggleGrid()
			winset(src,"MainWindow.SpectateButton","text='Join Play'")
			var/Winsets="MainWindow.StartButton.is-disabled=true;MainWindow.AutoStartButton.is-disabled=true;MainWindow.SellButton.is-disabled=true;"
			Winsets+="GoldModeButton.is-disabled=true;MainWindow.SplitGoldButton.is-visible=false;MainWindow.SharedGoldButton.is-visible=false;MainWindow.EarnedGoldButton.is-visible=false;"
			Winsets+="MainWindow.MainMap.focus=true"
			winset(src,null,Winsets)
		else
			Players+=src
			Spectators-=src
			src.UpdateGold()
			src.TroopHUD(src.TroopMenuCat)
			if(!src.see_invisible)	src.ToggleGrid()
			winset(src,"MainWindow.SpectateButton","text=Spectate")
			var/Winsets="MainWindow.StartButton.is-disabled=false;MainWindow.AutoStartButton.is-disabled=false;MainWindow.SellButton.is-disabled=false;"
			Winsets+="GoldModeButton.is-disabled=false;"
			Winsets+="MainWindow.MainMap.focus=true"
			winset(src,null,Winsets)
	ViewMedalScores()
		set name="View Medals & Scores"
		src<<link("http://www.byond.com/games/Falacy/Guardians#tab=scores")
	ToggleMusic()
		set hidden=1
		src.MusicVolume=!src.MusicVolume
		if(!src.MusicVolume)
			if(WaveInProgress)	src.FadeOutSound(src.FadingSounds["Night Music"])
			else	src.FadeOutSound(src.FadingSounds["Day Music"])
		else
			if(WaveInProgress)	src.FadeInSound(src.FadingSounds["Night Music"])
			else	src.FadeInSound(src.FadingSounds["Day Music"])
		src.SetFocus("MainWindow.MainMap")
	ToggleSoundEffects()
		set hidden=1
		src.SoundEffectVolume=!src.SoundEffectVolume
		src.SetFocus("MainWindow.MainMap")
	ToggleToolTips()
		set hidden=1
		src.ToolTipsOn=!src.ToolTipsOn
		src.SetFocus("MainWindow.MainMap")
	View_Credits()
		src<<"<font color=white><tt>Engine:</tt> BYOND"
		src<<"<font color=white><tt>Graphics:</tt> Strai"
		src<<"<font color=white><tt>* Water:</tt> SolarOblivion"
		src<<"<font color=white><tt>Game Programming:</tt> Strai"
		src<<"<font color=white><tt>HUD & Interface Design:</tt> Strai"
		src<<"<font color=white><tt>Audio:</tt> Firefly's Stronghold Series"
	ScreenShot()
		set hidden=1
		winset(src,,"command='.screenshot'")
	EscapeKey(/**/)
		set hidden=1
		src.Placing=null;src.client.mouse_pointer_icon=null
	Say(t as text)
		set hidden=1
		if(t)
			if(findtext(t,"://"))	{src<<"Link Filtered";return}
			world<<"\icon[src]<b>[src]:</b><font color=white> [html_encode(copytext(t,1,250))]"
	SellMode()
		set hidden=1
		src.Placing=null
		src.client.mouse_pointer_icon=icon('Other.dmi',"$",SOUTH)
		src.SetFocus("MainWindow.MainMap")
	ToggleAutoPlay()
		set hidden=1
		if(src in Players)	AutoPlay=!AutoPlay
		if(AutoPlay)	src.StartButton()
		src.SetFocus("MainWindow.MainMap")
		for(var/mob/Player/P in world)	if(P.client)	winset(P,"MainWindow.AutoStartButton","is-checked=[AutoPlay ? "true" : "false"]")
		//world<<"[src] Turned Auto Play [AutoPlay ? "On" : "Off"]"
	ToggleGrid()
		set hidden=1
		src.see_invisible=!src.see_invisible
		winset(src,"MainWindow.GridButton","is-checked=[src.see_invisible ? "true" : "false"]")
		src.SetFocus("MainWindow.MainMap")
	SetFocus(var/Window as text)
		set hidden=1
		winset(src,Window,"focus=true")
	Attack()
		set hidden=1
		flick("Battle",src)
		for(var/mob/Enemies/E in get_step(src,src.dir))
			src.MeleePower=E.MaxHP
			if("Hero" in E.Resistances)	src.MeleePower=E.MaxHP/2
			if("Melee" in E.Immunities)	src.MeleePower=E.MaxHP/3
			if(istype(E,/mob/Enemies/Bosses))	src.MeleePower=E.MaxHP/(Wave*10)
			ShowEffect(E,src.AttackAni,get_dir(src,E))
			for(var/mob/Player/P in orange(10,E))	P.PlaySoundEffect(pick(SwordSounds),"Swords")
			src.Damage(E,"Melee")
			return 1

mob/Player/Click(location,control,params)
	if(findtext(params,"right"))	{usr.EscapeKey();return}
	var/Amt2Give=input("Give Gold to [src]:","Give Gold",usr.Gold) as num
	Amt2Give=round(min(usr.Gold,Amt2Give))
	if(usr in Spectators)	return
	if(Amt2Give<=0)	return
	if(!src.client)	return
	if(usr==src)	return
	usr.TakeGold(Amt2Give,0)
	src.AddGold(Amt2Give)
	world<<"\icon['IntIcon.dmi'][usr] Gave [Amt2Give] Gold to [src]"