mob/verb/StartButton()
	set hidden=1
	src.SetFocus("MainWindow.MainMap")
	if(src in Spectators)	return
	if(src.CurTutorial=="Start Game")	src.CloseTutorial()
	if(!Wave)	src.verbs+=/mob/GM/verb/Restart
	StartWave()

var/list/SpawnLocs=list()
obj/EnemySpawner
	icon='Other.dmi'
	icon_state="Red X"
	invisibility=2

proc/StartWave(/**/)
	if(WaveInProgress)	return
	WaveInProgress=1;Wave+=1
	if(Wave==1)	for(var/mob/Player/P in world)	if(P.client)
		if(P.GoldModesOpen)	P.ToggleGoldModes()
	world.status="<b>[Players.len] Players on Wave [Wave] - Host: [world.host]</b>"
	//for(var/mob/Player/P in Players)	P.ModifyGold(round((200)/Players.len))
	if(Boss)	{global.GoldPot+=Wave*100;Boss=null}
	for(var/mob/Player/P in world)	{P.UpdateGold();P.NightTime()}
	if(!SpawnLocs.len)	for(var/obj/EnemySpawner/E in world)	SpawnLocs+=E.loc
	switch(Wave)
		if(1)	Enemies=list("Cobra")
		if(5)	Enemies+="Wolf"
		if(7)	Enemies+="WereWolf"
		if(10)
			Boss="Lycan"
			Enemies+="Goblin_Thug"
		if(15)	Enemies+="Goblin_Archer"
		if(17)	Enemies+="Goblin_Knight"
		if(20)
			Boss="Goblin_King"
			Enemies+="Skeleton"
		if(25)	Enemies+="Scavanger"
		if(27)	Enemies+="Giant"
		if(30)	Enemies+="Spider"
		if(33)
			Boss="Spider_Queen"
			Enemies+="Zombie"
		if(35)	Enemies+="Dragon"
		if(40)
			Boss="Dragon"
			Enemies+="Soul_Eater"
		if(43)	Enemies+="Mirror"
		if(47)	Enemies+="Zombie_Rabbit"
		if(50)
			Boss="Mummy"
			Enemies+="Soul_Reaver"
		if(53)	Enemies+="Vampire"
		if(55)
			Boss="Dracula"
			Enemies+="Bomb"
		if(57)	Enemies+="Corpse_Eater"
		if(60)	Enemies=list("Bosses/Spider_Queen","Bosses/Mummy","Bosses/Dragon")
	if(Enemies.len>=4)	Enemies.Cut(1,2)
	var/Enemies2Spawn=Wave*10
	Enemies2Spawn=min(500,Enemies2Spawn)
	var/TenPer=round(Enemies2Spawn*(10/100))
	Enemies2Spawn+=rand(-TenPer,TenPer)
	EnemiesRemaining=Enemies2Spawn
	for(var/i=1;i<=Enemies2Spawn;i++)
		if(!Wave)	break
		var/EnemyType
		if(Boss)
			EnemyType="/mob/Enemies/Bosses/[Boss]"
			var/mob/Enemies/E=new EnemyType(pick(SpawnLocs))
			E.MaxHP=Enemies2Spawn*100;E.HP=E.MaxHP
			E.MeleePower=round(Wave*2.5)
			E.MagicPower=round(Wave*2.5)
			EnemiesRemaining=1
			break
		else
			EnemyType="/mob/Enemies/[pick(Enemies)]"
			var/mob/Enemies/E=new EnemyType(pick(SpawnLocs))
			E.MaxHP+=Wave;E.HP=E.MaxHP
		sleep(rand(0,1))