obj/HUD
	icon='HUD.dmi'
	layer=10
	BG
		icon_state="Melee"
		screen_loc="1,-1 to 20,-1"
	BGG
		icon_state="Yellow"
		screen_loc="1,0 to 20,0"
	Troop_Categories
		var/TroopCat
		Click(location,control,params)
			if(findtext(params,"right"))	{usr.EscapeKey();return}
			if(usr in Spectators)	return
			if(usr.CurTutorial=="Troop Classes")	usr.ShowTutorial("You can move your Hero with the arrow keys or WASD, he will attack any enemies he runs into.","Hero Support","2,[720-136-64]")
			usr.TroopHUD(src.TroopCat)

mob/proc/TroopHUD(var/ThisCat)
	for(var/obj/HUD/BG/BG in src.client.screen)	BG.icon_state=ThisCat
	for(var/obj/Purchaseable/P in src.client.screen)	src.client.screen-=P
	var/screen_x=1
	if(ThisCat)
		src.TroopMenuCat=ThisCat
		for(var/obj/Purchaseable/O in src.Purchaseables)
			if(O.Category==ThisCat)
				O.screen_loc="[screen_x++],-1"
				O.layer=11;src.client.screen+=O

var/list/TroopButtonHUD=list()
proc/PopulateHUD()
	var/screen_x=1
	for(var/v in global.TroopTypes)
		for(var/LR in list("L","R"))
			var/obj/HUD/Troop_Categories/C=new()
			C.TroopCat=v;C.icon_state="[v][LR]"
			C.screen_loc="[screen_x++],0"
			global.TroopButtonHUD+=C

mob/proc/AddHUD()
	src.client.screen+=new/obj/HUD/BG
	src.client.screen+=new/obj/HUD/BGG
	src.client.screen+=global.TroopButtonHUD
	src.WriteHUDText(9,6,0,11,"Gold","Gold: 999,999,999 - Wave: 999.999")
	var/obj/MeleeClicker=global.TroopButtonHUD[1]
	MeleeClicker.Click()
	src.UpdateGold()