world
	name="Celestial Chaos: Guardians"
	hub="Falacy.Guardians"
	hub_password="GGToaKPasser"
	status="Idle - Join to Start!"
	mob=/mob/Player
	sleep_offline=1
	view=30
	New()
		world.log=file("LogFile.txt")
		ClearWorld()
		PopulateHUD()
		spawn()	LoadSubs(1)
		spawn()	SecondLoop()
		return ..()

var/GameTime=0
proc/SecondLoop()
	while(world)
		if(Wave && WaveInProgress)	GameTime+=1
		sleep(10)

client
	view="20x20"
	var/NumView=9
	control_freak=1
	show_popup_menus=0
	perspective=EDGE_PERSPECTIVE|EYE_PERSPECTIVE

client/Move(var/turf/NewTurf,var/NewDir)
	if(src.mob.CurTutorial=="Hero Support")
		src.mob.ShowTutorial("Ready to Guard your Gold?  Press the Start button below to begin the first night!","Start Game","2,[720-136-64-32]")
	for(var/mob/Enemies/E in NewTurf)
		src.mob.dir=NewDir
		src.mob.Attack()
		return
	if(NewTurf && NewTurf.density)	{src.mob.dir=NewDir;return}
	return ..()
	//below prevents entering the edges of the map
	src.mob.dir=NewDir
	switch(NewDir)
		if(NORTH)	if(src.mob.y==world.maxy-src.NumView)	return
		if(SOUTH)	if(src.mob.y==src.NumView+1)	return
		if(EAST)	if(src.mob.x==world.maxx-src.NumView)	return
		if(WEST)	if(src.mob.x==src.NumView+1)	return
	return ..()

mob/proc/SetupIcon()
	src.icon='Aralian.dmi'
	src.icon_state="Walk"
	src.overlays+=pick('Loose.dmi','MessySpikes.dmi','Spiked.dmi','SpikedBack.dmi')
	src.overlays+='Boots.dmi'
	src.overlays+='Legs.dmi'
	src.overlays+='Armor.dmi'
	src.overlays+='Sleeves.dmi'
	src.overlays+='Gloves.dmi'
	src.overlays+='CapeSides.dmi'
	src.overlays+='SwordRight.dmi'
	src.overlays+='Shield.dmi'
	src.overlays+='Cape.dmi'

mob/Player
	layer=6;density=0
	mouse_opacity=0
	sight=SEE_MOBS|SEE_TURFS|SEE_OBJS
	MouseEntered()
		if(src.client)	usr.ToolTip("Click to Give Gold...","[src.name] Lvl.[src.Level] Hero")
		else	usr.ToolTip("This Player is Offline...","[src.name] Lvl.[src.Level] Hero")
	MouseExited()
		usr.CloseToolTip()

mob/Player/Login()
	Players+=src
	Spectators-=src
	src.SubCheck()
	if(src.name==src.key)
		src.SetupIcon()
		src.loc=locate(26,26,1)
		world<<"<b>[src] Arrived"
		spawn()	src.SoundCooldown()
		if(Wave)	src.LateJoiner=1
		src.GiveMedal("Guardian","Login to the Game")
		if(findtext(src.key,"Guest-"))	src<<"<font color=red>Note: Guests cannot set hub scores.\nCreate a free account at http://www.BYOND.com"
		else	spawn(-1)	world.SetScores(src.key,list2params(list("HubContact"=1)))
		src.Purchaseables=list();for(var/v in typesof(/obj/Purchaseable))	src.Purchaseables+=new v
	else
		src.name=src.key
		world<<"<b>[src] Returned"
	if(!WaveInProgress)	src.DayTime()
	else	src.NightTime()
	src.AddHUD()
	src.AddName()
	src.ResetToggleOptions()
	if(src.key==world.host)	src.verbs+=typesof(/mob/GM/verb)
	winset(src,"MainWindow","pos=0,0;size=1024x768;is-maximized=true")
	winset(src,"MainWindow.GoldModeButton","text='Gold: [GoldMode]'")
	src.ShowTutorial("Click a troop from the menus below.  Then, click the map to deploy them.","Deploying Troops","2,[720-136-64]")
	if(src.client.IsByondMember())	src.GiveMedal("BYOND Member","Have an Active BYOND Membership")

mob/Logout()
	Players-=src
	Spectators-=src
	Spectators+=src
	world<<"<b>[src] Left"
	GoldPot+=src.Gold;src.Gold=0;src.suffix=""
	src.name="[src.key] (Offline)";src.AddName()
	for(var/mob/Player/P in world)	P.UpdateGold()
	if(!Players.len)	ClearWorld()