obj/Corpse
	mouse_opacity=0
	icon='Troops.dmi'
	var/mob/Troops/Troop
	New(var/mob/Troops/T)
		src.Troop=T
		src.loc=T.loc
		spawn(rand(15,30))
			if(src.Troop && src.Troop.loc==null)	del src.Troop
			src.loc=null

obj/NightHUD
	layer=20
	mouse_opacity=0
	icon='Other.dmi'
	icon_state="Night"
	screen_loc="1,1 to 20,20"

sound/var/FadeID
mob/proc/FadeInSound(var/sound/Sound)
	if(!src.MusicVolume)	return
	spawn(-1)
		Sound.volume=0
		Sound.status=SOUND_UPDATE
		var/ThisID=rand(1,999999)
		Sound.FadeID=ThisID
		while(Sound.volume<100 && Sound.FadeID==ThisID)
			Sound.volume+=10
			Sound.status=SOUND_UPDATE
			src<<Sound
			sleep(3)
		Sound.status=null

mob/proc/FadeOutSound(var/sound/Sound)
	spawn(-1)
		var/ThisID=rand(1,999999)
		Sound.FadeID=ThisID
		while(Sound.volume>0 && Sound.FadeID==ThisID)
			Sound.volume-=10
			Sound.status=SOUND_UPDATE
			src<<Sound
			sleep(3)
		Sound.status=null
		src<<Sound

mob/var/obj/NightHUD/NightHUD=new
mob/proc/NightTime()
	if(!src.client)	return
	src.FadeOutSound(src.FadingSounds["Day Music"])
	src.FadeInSound(src.FadingSounds["Night Music"])
	src.client.screen-=src.NightHUD
	src.client.screen+=src.NightHUD
	flick("NightFade",NightHUD)
	NightHUD.icon_state="Night"

mob/proc/DayTime()
	if(!src.client)	return
	if(global.Wave)	src.FadeOutSound(src.FadingSounds["Night Music"])
	src.FadeInSound(src.FadingSounds["Day Music"])
	src.client.screen-=src.NightHUD
	src.client.screen+=src.NightHUD
	flick("DawnFade",NightHUD)
	NightHUD.icon_state=""