obj/Purchaseable
	TroopUpgrades
		Level=1
		Cost=150
		Type="Upgrade"
		icon='Upgrades.dmi'

		Click(location,control,params)
			if(findtext(params,"right"))	{usr.EscapeKey();return}
			if(!src.MultiBuy && (src in usr.Upgrades))	{usr.PlayVoiceWarning('placement_warning15.ogg');return}
			if(!usr.TakeGold(src.Cost))	{usr.PlayVoiceWarning(pick(GoldWarnings-usr.LastVoiceHeard));return}
			if(src.MultiBuy)	{src.Level+=1;src.Cost*=2;src.name="[initial(src.name)] +[src.Level-1]"}
			if(!(src in usr.Upgrades))	usr.Upgrades+=src
			for(var/mob/Troops/T in world)	if(T.Owner==usr)	src.ApplyToTroop(T)
			usr.PlayTroopVoice(pick(global.TroopTypes[src.Category]-usr.LastVoiceHeard))
			src.MouseEntered()

		proc/ApplyToTroop(var/mob/Troops/T,var/ResetImages)
			if(!(src.name in T.Upgrades))
				T.Upgrades+=src.name
				ShowEffect(T,"Level UP")
				if(ResetImages)	T.ResetImages()

		Melee_Upgade
			MultiBuy=1
			Category="Melee"
			icon_state="Melee"
			desc="Increases Melee Troops Damage by 1."
			ApplyToTroop(var/mob/Troops/T)
				if("Melee" in T.AttackTypes)
					T.MeleePower=initial(T.MeleePower)+src.Level-1
					return ..(T)
		Block
			Cost=500
			Category="Melee"
			icon_state="Block"
			desc="Gives Melee Troops a 25% Chance to Block."
			ApplyToTroop(var/mob/Troops/T)
				if("Melee" in T.AttackTypes)	return ..(T)
		Deflect
			Cost=750
			Category="Melee"
			icon_state="Deflect"
			desc="Gives Melee Troops a 25% Chance to Block Arrows."
			ApplyToTroop(var/mob/Troops/T)
				if("Melee" in T.AttackTypes)	return ..(T)
		Immunity
			Cost=1000
			Category="Melee"
			icon_state="Immunity"
			desc="Make Melee Troops Immune to Poison Effects."
			ApplyToTroop(var/mob/Troops/T)
				if("Melee" in T.AttackTypes)	return ..(T)


		Ranged_Upgade
			MultiBuy=1
			Category="Ranged"
			icon_state="Ranged"
			desc="Increases Ranged Troops Damage by 1."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					T.RangedPower=initial(T.RangedPower)+src.Level-1
					return ..(T)
		Arc
			Cost=300
			Category="Ranged"
			icon_state="Arc"
			desc="Shoot Over Walls and Across Water."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					return ..(T,1)
		Range_Plus
			Cost=500
			name="Range +"
			Category="Ranged"
			icon_state="Range +"
			desc="Increases Ranged Troops Attack Radius by 3."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					T.Range+=3
					return ..(T,1)
		Range_PlusPlus
			Cost=750
			name="Range ++"
			Category="Ranged"
			icon_state="Range ++"
			desc="Increases Ranged Troops Attack Radius by 5."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					T.Range+=5
					return ..(T,1)
		Range_PlusPlusPlus
			Cost=1500
			name="Range +++"
			Category="Ranged"
			icon_state="Range +++"
			desc="Increases Ranged Troops Attack Radius by 10."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					T.Range+=10
					return ..(T,1)
		Long_Shot
			Cost=5000
			Category="Ranged"
			icon_state="Long Shot"
			desc="Increases Ranged Troops Attack Radius by 27."
			ApplyToTroop(var/mob/Troops/T)
				if("Ranged" in T.AttackTypes)
					T.Range+=27
					return ..(T,1)


		Light_Magic_Upgade
			MultiBuy=1
			Category="Light Magic"
			icon_state="Light Magic"
			desc="Increases Light Magic Healing by 1."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)
					T.HealingPower=initial(T.HealingPower)+src.Level-1
					return ..(T)
		Radial_Heal
			Cost=300
			Category="Light Magic"
			icon_state="Radial Heal"
			desc="Allows Healing of Multiple Troops at Once."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Cure
			Cost=500
			Category="Light Magic"
			icon_state="Cure"
			desc="Remove Poisonous Status Effects from Troops."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Radial_Cure
			Cost=750
			Category="Light Magic"
			icon_state="Radial Cure"
			desc="Allows Curing of Multiple Troops at Once."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Needle
			Cost=1000
			Category="Light Magic"
			icon_state="Needle"
			desc="Remove Silence Status Effects from Troops."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Loud
			Cost=1500
			Category="Light Magic"
			icon_state="Loud"
			desc="Makes Light Mages Immune to Silence Effects."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Purify
			Cost=2000
			Category="Light Magic"
			icon_state="Purify"
			desc="Remove Vampirism Status Effects from Troops."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)
		Break
			Cost=3000
			Category="Light Magic"
			icon_state="Break"
			desc="Summons Boulders Down Upon Enemies."
			ApplyToTroop(var/mob/Troops/T)
				if("Healing" in T.AttackTypes)	return ..(T)


		Dark_Magic_Upgade
			MultiBuy=1
			Category="Dark Magic"
			icon_state="Dark Magic"
			desc="Increases Dark Magic Damage by 1."
			ApplyToTroop(var/mob/Troops/T)
				if("Magic" in T.AttackTypes)
					T.MagicPower=initial(T.MagicPower)+src.Level-1
					return ..(T)
		Insight
			Cost=300
			Category="Dark Magic"
			icon_state="Insight"
			desc="Cast Through Walls and Across Water."
			ApplyToTroop(var/mob/Troops/T)
				if("Magic" in T.AttackTypes)
					return ..(T,1)
		Inferno
			Cost=500
			Category="Dark Magic"
			icon_state="Inferno"
			desc="Nearby Targets of Targets will Burst into Flames."
			ApplyToTroop(var/mob/Troops/T)
				if("Magic" in T.AttackTypes)	return ..(T)
		Free_Burn
			Cost=750
			Category="Dark Magic"
			icon_state="Free Burn"
			desc="Burn Nets and Webbing to Free Disabled Troops."
			ApplyToTroop(var/mob/Troops/T)
				if("Magic" in T.AttackTypes)	return ..(T)
		Fire_Aura
			Cost=1000
			Category="Dark Magic"
			icon_state="Fire Aura"
			desc="Makes Dark Mages Immune to Disabling Effects."
			ApplyToTroop(var/mob/Troops/T)
				if("Magic" in T.AttackTypes)	return ..(T)